/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.army.hierarchy;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import javax.swing.Icon;
import javax.swing.tree.MutableTreeNode;
/**
 * a node in the tree table
 * @author Farfpeuf
 */
public abstract class HierarchyNode implements MutableTreeNode {
	//property changes delegate
	protected PropertyChangeSupport support;
	/**
	 * @return node full name
	 */
	public abstract String getFullName();
	/**
	 * @return node cost
	 */
	public abstract int getCost();
	/**
	 * @return node number of warriors
	 */
	public abstract int getNumberOfWarriors();
	/**
	 * @return icon used in tree table
	 */
	public abstract Icon getMinicon();
	/**
	 * constructor
	 * initialize PropertyChangeSupport
	 */
	public HierarchyNode() {
		support = new PropertyChangeSupport(this);
	}

	/**
	 * @return number of warriors as a string
	 */
	public String numberString(){
		return Integer.toString(getNumberOfWarriors());
	}
	
	//------------------PropertyChange delegate methods
	
	public void addPropertyChangeListener(String arg0,
			PropertyChangeListener arg1) {
		support.addPropertyChangeListener(arg0, arg1);
	}
	public void firePropertyChange(String arg0, boolean arg1, boolean arg2) {
		support.firePropertyChange(arg0, arg1, arg2);
	}
	public void firePropertyChange(String arg0, int arg1, int arg2) {
		support.firePropertyChange(arg0, arg1, arg2);
	}
	public void firePropertyChange(String arg0, Object arg1, Object arg2) {
		support.firePropertyChange(arg0, arg1, arg2);
	}
	public void removePropertyChangeListener(String arg0,
			PropertyChangeListener arg1) {
		support.removePropertyChangeListener(arg0, arg1);
	}

	public void addPropertyChangeListener(PropertyChangeListener listener) {
		support.addPropertyChangeListener(listener);
	}

	
}