/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.Color;

import fb.gui.widgets.FBTextArea;
import fb.util.FBColors;

/**
 * text area used to diplay messages to user
 * 
 * @author farfpeuf
 */
public class MessageArea extends FBTextArea {

	/**
	 * singleton instance
	 */
	private static MessageArea instance;

	/**
	 * get singleton instance
	 * 
	 * @return the singleton
	 */
	public static synchronized MessageArea getInstance() {
		if (null == instance) {
			instance = new MessageArea();
		}

		return instance;

	}

	/**
	 * append a message in area
	 * 
	 * @param mess
	 *            the message
	 * @param color
	 *            the message color
	 */
	public void message(String mess, Color color) {
		appendText(mess, color);
	}

	/**
	 * append a message in area using default color
	 * 
	 * @param mess
	 *            the message
	 */
	public void message(String mess) {
		message(mess, FBColors.standardText);
	}

}
