/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.widgets;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.border.Border;

import fb.util.Resources;

/**
 * a fantasy battlefields custom toolbar button
 * 
 * @author Farfpeuf
 */
public class FBToolBarButton extends JButton implements MouseListener {
	/**
	 * the button action listener
	 */
	protected ActionListener actionlistener = null;

	/**
	 * constructor
	 * 
	 * @param iconName
	 *            the button icon name
	 */
	public FBToolBarButton(String iconName) {
		super();
		setIcon(Resources.getButtonIcon(iconName));
		setBorder(BorderFactory.createEmptyBorder());
		setOpaque(false);
		addMouseListener(this);
	}

	// mouse listener implementation
	public void mouseClicked(MouseEvent event) {
	}

	public void mousePressed(MouseEvent event) {

	}

	public void mouseEntered(MouseEvent e) {

	}

	public void mouseExited(MouseEvent e) {

	}

	/**
	 * button is released
	 */
	public void mouseReleased(MouseEvent event) {
		if (actionlistener != null) {
			actionlistener.actionPerformed(new ActionEvent(this, 0, "clic"));
		}
	}

	// no border
	public void setBorder(Border b) {
	}

	/**
	 * set button action listener
	 */
	public void addActionListener(ActionListener al) {
		actionlistener = al;
	}

}
