/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.util;

import java.io.File;
import java.util.Arrays;
import java.util.Hashtable;

/**
 * registerable list of files in a directoy
 * 
 * @author farfpeuf
 *
 */
public class FileArrayListModel extends ArrayListModel {
/**
 * the file directory
 */
	private File directory;
	/**
	 * singleton instances
	 */
	private static Hashtable instances=new Hashtable();
	/**
	 * constructor
	 * @param directoryPath the files directory path
	 */
	private FileArrayListModel(String directoryPath) {
		super();
		directory = new File(directoryPath);
		refresh();
	}
	/**
	 * refresh the directory
	 *
	 */
	private void refresh(){
		String[] filelist = directory.list();
		clear();
		addAll(Arrays.asList(filelist));
	}
	/**
	 * refresh an instance
	 * @param directoryPath the instance directory path
	 */
	public static synchronized void refresh(String directoryPath){
		FileArrayListModel instance=(FileArrayListModel)instances.get(directoryPath);
		if(instance!=null){
			instance.refresh();
		}
	}	
	/**
	 * get one of the singleton instances
	 * @param directoryPath the instance directory path
	 * @return the singleton
	 */
	public static synchronized FileArrayListModel getInstance(String directoryPath){
		FileArrayListModel instance=(FileArrayListModel)instances.get(directoryPath);
		if(instance==null){
			instance=new FileArrayListModel(directoryPath);
			instances.put(directoryPath,instance);
		}
		return instance;
	}
}
